// AITank.h - Controller for Enemy Tank

#pragma once

#include "Tank.h"
#include "Actor.h"
#include "Messenger.h"
#include "Steering.h"

class AITank : public Actor
{
	Steering m_Steering;
	Tank m_Tank;
	int m_Health;
	static const int m_MaxHealth;
	float m_LastBaseYaw;
	float m_LastTurretYaw;
	float m_StartingPause;

public:
	AITank(int ID);
	void Update(float dt);
	void Render();
	void ReceiveMessage(Telegram incoming);
	Tank* GetTank(){return &m_Tank;}
	int GetHealth(){return m_Health;}
	void AdjustHealth(int amount){m_Health += amount;}
};