#pragma once
#include "Actor.h"
#include <map>
#include "d3dx9.h"

class ActorManager
{
	std::map<int, Actor*> m_ActorMap;
	ActorManager();
	ActorManager(ActorManager&){}
	void operator= (ActorManager&){}

	//Special actors
	Actor* m_Player;
	Actor* m_ActiveCamera;
	Actor* m_ActiveAITank;
	Actor* m_ActiveCannon;
	D3DLIGHT9 m_MainLight;
public:
	static ActorManager* Instance();

	//Accessors
	Actor* GetActor(int ID);
	D3DLIGHT9 GetMainLight(){return m_MainLight;}
	Actor* GetActiveCamera(){return m_ActiveCamera;}
	Actor* GetPlayer(){return m_Player;}
	Actor* GetActiveAITank(){return m_ActiveAITank;}
	Actor* GetActiveCannon(){return m_ActiveCannon;}

	//Mutators
	void SetPlayer(Actor* player){m_Player = player; AddActor(player);}
	void SetActiveCamera(Actor* camera){m_ActiveCamera = camera; AddActor(camera);}
	void SetActiveAITank(Actor* tank){m_ActiveAITank = tank; AddActor(tank);}
	void SetActiveCannon(Actor* cannon){m_ActiveCannon = cannon; AddActor(cannon);}

	void AddActor(Actor* actor);
	void RemoveActor(int ID);
	void Update(float dt);
	void Render();
	void Reset();
};