#pragma once
#include "d3dx9.h"
#include <map>
#include <string>

class AssetManager
{
	std::map<std::string, IDirect3DTexture9*>  m_TextureMap;
	std::map<std::string, ID3DXMesh*>  m_MeshMap;
	std::map<std::string, ID3DXEffect*> m_ShaderMap;

	AssetManager();
	AssetManager(AssetManager&){}
	void operator=(AssetManager&){}
	bool  m_MenuLoaded;
	bool  m_GameLoaded;

public:
	static AssetManager* Instance();
	~AssetManager();

	void LoadGameAssets();
	void LoadMenuAssets();

	IDirect3DTexture9* GetTexture(std::string);
	ID3DXMesh* GetMesh(std::string);
	ID3DXEffect* GetShader(std::string);

	void onResetDevice();
	void onLostDevice();

};