#pragma once
#include "d3dx9.h"

//Define all global shortcuts/constants here

//Shortcut to the Input Device
#define gInput DInputFramework::Instance()
//Shortcut to the Application Instance
#define gApplication DirectX9App::Instance()
//Shortcut to the main Direct3D Device
#define gD3DDevice DirectX9App::Instance()->GetDevice()
//Shortcut to the Sprite Interface
#define gSprite DirectX9App::Instance()->GetSprite()
//Shortcut to the Game FSM
#define gGame DirectX9Game::Instance()
//Shortcut to the actor manager
#define gActors ActorManager::Instance()
//Shortcut to the actor factory
#define gFactory ActorFactory::Instance()
//Shortcut to Asset Manager
#define gAssets AssetManager::Instance()
//Shortcut to the messenger
#define gMessenger Messenger::Instance()
//Shortcut to the FMOD Audio handler
#define gAudio FMODAudio::Instance()


// Macro to release COM objects fast and safely
#define SAFE_RELEASE(x) if(x){x->Release(); x = 0;}

// HRESULT macro that prints an error window
#ifndef HR
#define HR(x)												\
		{                                                   \
		HRESULT hr = x;									    \
		if(FAILED(hr))									    \
			{                                               \
			DXTraceA(__FILE__, __LINE__, hr, #x, TRUE);	    \
			}                                               \
		}                                                   
#endif

//Pre Defined colors.
const D3DXCOLOR WHITE(1.0f, 1.0f, 1.0f, 1.0f);
const D3DXCOLOR BLACK(0.0f, 0.0f, 0.0f, 1.0f);
const D3DXCOLOR RED(1.0f, 0.0f, 0.0f, 1.0f);
const D3DXCOLOR GREEN(0.0f, 1.0f, 0.0f, 1.0f);
const D3DXCOLOR BLUE(0.0f, 0.0f, 1.0f, 1.0f);
const D3DXCOLOR PURPLE(0.5f, 0.0f, 1.0f, 1.0f);
const D3DXCOLOR YELLOW(1.0f, 1.0f, 0.0f, 1.0f);
const D3DXCOLOR ORANGE(1.0f, 0.5f, 0.0f, 1.0f);

//Math Constants
const float INFINITY = FLT_MAX;
const float EPSILON = 0.001f;