#include "DirectInput.h"
#include "Defines.h"
#include "DirectX9App.h"

DInputFramework::~DInputFramework()
{
	Shutdown();
}

bool DInputFramework::KeyDown(char key)
{
	if(m_KeyboardState[key] & 0x80)
		return true;
	else
		return false;
}

bool DInputFramework::KeyReleased(char key)
{
	if((m_PrevKeyboardState[key] & 0x80) && !KeyDown(key))
		return true;
	else
		return false;
}

bool DInputFramework::KeyHeld(char key)
{
	if((m_PrevKeyboardState[key] & 0x80) && KeyDown(key))
		return true;
	else
		return false;
}

std::string DInputFramework::GetText()
{
	if(KeyDown(DIK_A) && !KeyHeld(DIK_A))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "A";
		else
			return "a";
	}
	if(KeyDown(DIK_B) && !KeyHeld(DIK_B))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "B";
		else
			return "b";
	}
	if(KeyDown(DIK_C) && !KeyHeld(DIK_C))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "C";
		else
			return "c";
	}
	if(KeyDown(DIK_D) && !KeyHeld(DIK_D))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "D";
		else
			return "d";
	}
	if(KeyDown(DIK_E) && !KeyHeld(DIK_E))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "E";
		else
			return "e";
	}
	if(KeyDown(DIK_F) && !KeyHeld(DIK_F))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "F";
		else
			return "f";
	}
	if(KeyDown(DIK_G) && !KeyHeld(DIK_G))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "G";
		else
			return "g";
	}
	if(KeyDown(DIK_H) && !KeyHeld(DIK_H))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "H";
		else
			return "h";
	}
	if(KeyDown(DIK_I) && !KeyHeld(DIK_I))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "I";
		else
			return "i";
	}
	if(KeyDown(DIK_J) && !KeyHeld(DIK_J))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "J";
		else
			return "j";
	}
	if(KeyDown(DIK_K) && !KeyHeld(DIK_K))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "K";
		else
			return "k";
	}
	if(KeyDown(DIK_L) && !KeyHeld(DIK_L))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "L";
		else
			return "l";
	}
	if(KeyDown(DIK_M) && !KeyHeld(DIK_M))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "M";
		else
			return "m";
	}
	if(KeyDown(DIK_N) && !KeyHeld(DIK_N))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "N";
		else
			return "n";
	}
	if(KeyDown(DIK_O) && !KeyHeld(DIK_O))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "O";
		else
			return "o";
	}
	if(KeyDown(DIK_P) && !KeyHeld(DIK_P))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "P";
		else
			return "p";
	}
	if(KeyDown(DIK_Q) && !KeyHeld(DIK_Q))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "Q";
		else
			return "q";
	}
	if(KeyDown(DIK_R) && !KeyHeld(DIK_R))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "R";
		else
			return "r";
	}
	if(KeyDown(DIK_S) && !KeyHeld(DIK_S))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "S";
		else
			return "s";
	}
	if(KeyDown(DIK_T) && !KeyHeld(DIK_T))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "T";
		else
			return "t";
	}
	if(KeyDown(DIK_U) && !KeyHeld(DIK_U))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "U";
		else
			return "u";
	}
	if(KeyDown(DIK_V) && !KeyHeld(DIK_V))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "V";
		else
			return "v";
	}
	if(KeyDown(DIK_W) && !KeyHeld(DIK_W))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "W";
		else
			return "w";
	}
	if(KeyDown(DIK_X) && !KeyHeld(DIK_X))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "X";
		else
			return "x";
	}
	if(KeyDown(DIK_Y) && !KeyHeld(DIK_Y))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "Y";
		else
			return "y";
	}
	if(KeyDown(DIK_Z) && !KeyHeld(DIK_Z))
	{
		if(KeyDown(DIK_LSHIFT) || KeyDown(DIK_RSHIFT))
			return "Z";
		else
			return "z";
	}
	if(KeyDown(DIK_1) && !KeyHeld(DIK_1))
	{
		return "1";
	}
	if(KeyDown(DIK_2) && !KeyHeld(DIK_2))
	{
		return "2";
	
	}
	if(KeyDown(DIK_3) && !KeyHeld(DIK_3))
	{	return "3";
	}
	if(KeyDown(DIK_4) && !KeyHeld(DIK_4))
	{
		return "4";
	}
	if(KeyDown(DIK_5) && !KeyHeld(DIK_5))
	{
		return "5";
	}
	if(KeyDown(DIK_6) && !KeyHeld(DIK_6))
	{
		return "6";
	}
	if(KeyDown(DIK_7) && !KeyHeld(DIK_7))
	{
		return "7";
	}
	if(KeyDown(DIK_8) && !KeyHeld(DIK_8))
	{
		return "8";
	}
	if(KeyDown(DIK_9) && !KeyHeld(DIK_9))
	{
		return "9";
	}
	if(KeyDown(DIK_0) && !KeyHeld(DIK_0))
	{
		return "0";
	}
	if(KeyDown(DIK_SPACE) && !KeyHeld(DIK_SPACE))
	{
		return " ";
	}
}

bool DInputFramework::MouseButtonDown(int button)
{
	if(m_MouseState.rgbButtons[button] & 0x80)
		return true;
	else
		return false;
}

bool DInputFramework::MouseButtonReleased(int button)
{
	if((m_PrevMouseState.rgbButtons[button] & 0x80) && !MouseButtonDown(button))
		return true;
	else
		return false;
}

bool DInputFramework::MouseButtonHeld(int button)
{
	if((m_PrevMouseState.rgbButtons[button] & 0x80) && MouseButtonDown(button))
		return true;
	else
		return false;
}

void DInputFramework::Init(HWND hWnd, HINSTANCE hInst)
{
	HR(DirectInput8Create(hInst, DIRECTINPUT_VERSION, IID_IDirectInput8, (void**)&m_pInput, NULL));

	HR(m_pInput->CreateDevice(GUID_SysKeyboard, &m_pKeyboard, NULL));
	HR(m_pInput->CreateDevice(GUID_SysMouse, &m_pMouse, NULL));

	//Data formats
	HR(m_pKeyboard->SetDataFormat(&c_dfDIKeyboard));
	HR(m_pMouse->SetDataFormat(&c_dfDIMouse2));

	//Cooperative Levels
	HR(m_pKeyboard->SetCooperativeLevel(hWnd, KEYBOARD_COOP_FLAGS));
	HR(m_pMouse->SetCooperativeLevel(hWnd, MOUSE_COOP_FLAGS));

	//Aquire Devices
	HR(m_pKeyboard->Acquire());
	HR(m_pMouse->Acquire());

	//Initialize keyboard and mouse states
	for(int i = 0; i < 256; ++i)
	{
		m_PrevKeyboardState[i] = false;
	}
	ZeroMemory(m_KeyboardState, sizeof(m_KeyboardState));
	ZeroMemory(&m_MouseState, sizeof(m_MouseState));
	ZeroMemory(&m_PrevMouseState, sizeof(m_PrevMouseState));
	POINT p;
	GetCursorPos(&p);
	ScreenToClient(gApplication->GetMainWnd(), &p);
	m_MousePos.x = (float)p.x;
	m_MousePos.y = (float)p.y;

	//Load Mouse Cursor texture
	D3DXCreateTextureFromFile(gD3DDevice, MOUSE_CURSOR, &m_CursorTexture);
}

void DInputFramework::Update()
{
	//Update previous states.
	for(int i = 0; i < 256; ++i)
	{
		m_PrevKeyboardState[i] = m_KeyboardState[i];
	}

	m_PrevMouseState = m_MouseState;

	//Get keyboard input. If failed, zero out the keyboard state and reacquire the keyboard for next update.
	HRESULT hr = m_pKeyboard->GetDeviceState(sizeof(m_KeyboardState), (LPVOID)&m_KeyboardState);
	if(FAILED(hr))
	{
		ZeroMemory(m_KeyboardState, sizeof(m_KeyboardState));
		HR(m_pKeyboard->Acquire());
	}

	//Get mouse input. If failed, zero out mouse state and reacquire the mouse for next update.
	hr = m_pMouse->GetDeviceState(sizeof(DIMOUSESTATE2), &m_MouseState);
	if(FAILED(hr))
	{
		ZeroMemory(&m_MouseState, sizeof(m_MouseState));
		HR(m_pMouse->Acquire());
	}

	//Update mouse position
	POINT p;
	GetCursorPos(&p);
	ScreenToClient(gApplication->GetMainWnd(), &p);
	m_MousePos.x = (float)p.x;
	m_MousePos.y = (float)p.y;
}

void DInputFramework::Render()
{
	//Draw mouse position
	D3DXMATRIX worldMat;
	D3DXMatrixIdentity(&worldMat);
	gSprite->SetTransform(&worldMat);
	char buffer[64];

	sprintf_s(buffer, "X: %d\nY: %d", (int)gInput->GetMousePos().x, (int)gInput->GetMousePos().y);
//	gApplication->GetDefaultFont()->DrawText(gSprite, buffer, -1, &gApplication->GetWindowRect(), DT_TOP | DT_LEFT | DT_NOCLIP, D3DCOLOR_ARGB(255,0,0,0));
		
	//Draw mouse cursor
	D3DXMatrixIdentity(&worldMat);
	D3DXMatrixTranslation(&worldMat, m_MousePos.x, m_MousePos.y, 0.0f);
	gSprite->SetTransform(&worldMat);
	HR(gSprite->Draw(m_CursorTexture, 0, 0, 0, D3DCOLOR_ARGB(255,0,0,0)));
	HR(gSprite->Flush());

}

void DInputFramework::Shutdown()
{
	//Unaquire input devices and release members
	SAFE_RELEASE(m_pInput);
	SAFE_RELEASE(m_pMouse);
	SAFE_RELEASE(m_pKeyboard);
	
}

DInputFramework* DInputFramework::Instance()
{
	static DInputFramework instance;
	return &instance;
}
