#pragma once

#include "fmod.hpp"
#include "fmod_errors.h"
#pragma comment(lib, "fmodex_vc.lib")
#include <string>
#include <map>

class FMODAudio
{
	FMOD::System*					m_pFMODsystem;			//Main FMOD System
	FMOD::Channel*					m_pFXChannel;			//Sound Effect Channel
	FMOD::Channel*					m_pMusicChannel;		//Background Music Channel
	std::map<std::string, FMOD::Sound*> m_SoundMap;

	FMODAudio();
	FMODAudio(FMODAudio&){}
	void operator=(FMODAudio&){}
public:
	static FMODAudio* Instance();
	~FMODAudio();
	void Update();
	void PlaySoundFX(std::string filename);
	void PlaySong(std::string filename);
	void StopSong();
};