#include "GameStateMenuCredits.h"
#include "DirectInput.h"
#include "DirectX9Game.h"
#include "GameStatePlaying.h"
#include "GameStateMenuMain.h"
#include "FMODAudio.h"

GameStateMenuCredits::GameStateMenuCredits()
{



}

GameStateMenuCredits::~GameStateMenuCredits()
{



}

GameStateMenuCredits* GameStateMenuCredits::Instance()
{
	static GameStateMenuCredits instance;
	return &instance;
}

void GameStateMenuCredits::Enter(DirectX9Game* owner)
{
	m_Selection = CreditsNone;
	//Init the button RECTs
	m_ButtonMain.bottom = 870;
	m_ButtonMain.top = 800;
	m_ButtonMain.left = 480;
	m_ButtonMain.right = 830;

}

void GameStateMenuCredits::Execute(DirectX9Game* owner, float dt)
{
	m_SelectionLast = m_Selection;
	//Check mouse position against button rects if mouse has moved.
	if(D3DXVec3Length(&gInput->GetMouseMovement()) > 0.001f)
	{
		D3DXVECTOR2 mousePos = gInput->GetMousePos();
		if((mousePos.x > m_ButtonMain.left) && (mousePos.x < m_ButtonMain.right) && (mousePos.y > m_ButtonMain.top) && (mousePos.y < m_ButtonMain.bottom))
		{
			m_Selection = CreditsMenuSelection::CreditsMain;
		}
	}
	//Get Keyboard input to change selection
	if(gInput->KeyReleased(DIK_A) || gInput->KeyReleased(DIK_W) || gInput->KeyReleased(DIK_D) || gInput->KeyReleased(DIK_S))
	{
		if(m_Selection == CreditsMenuSelection::CreditsNone)
			m_Selection = CreditsMenuSelection::CreditsMain;

	}

	if(m_Selection != m_SelectionLast)
		gAudio->PlaySoundFX("Menu_Hover.wav");

	//If mouse clicked or enter pressed and button selected, process that selection
	if(gInput->KeyDown(DIK_RETURN) || gInput->MouseButtonDown(0))
	{
		gAudio->PlaySoundFX("Cannon_Hit.wav");
		if(m_Selection == CreditsMain)
			owner->GetFSM()->ChangeState(GameStateMenuMain::Instance());
	}

}


void GameStateMenuCredits::Exit(DirectX9Game* owner)
{

}


void GameStateMenuCredits::Render(DirectX9Game* owner)
{
	//Draw button textures based on selection.
	gInput->Render();
	D3DXMATRIX worldMat, scaleMat;

	//Draw Background
	D3DXMatrixScaling(&scaleMat, 0.7f, 1.0f, 1.0f);
	D3DXMatrixTranslation(&worldMat, -40.0f, 0.0f, 0.0f);
	worldMat = scaleMat * worldMat;
	gSprite->SetTransform(&worldMat);
	gSprite->Draw(gAssets->GetTexture("Tank_Background.png"), 0, 0, 0, D3DCOLOR_ARGB(255,255,255,255));
	gSprite->Flush();

	D3DXMatrixScaling(&scaleMat, 2.0f, 2.0f, 2.0f);
	D3DXMatrixTranslation(&worldMat, gApplication->GetWindowSize().x / 3.0f, 3 * gApplication->GetWindowSize().y / 4.0f, 0.0f);
	worldMat = scaleMat * worldMat;
	gSprite->SetTransform(&worldMat);
	if(m_Selection == CreditsMain)
		gSprite->Draw(gAssets->GetTexture("Main_Menu_Selected.png"), 0, 0, 0, D3DCOLOR_ARGB(255,255,255,255));
	else
		gSprite->Draw(gAssets->GetTexture("Main_Menu.png"), 0, 0, 0, D3DCOLOR_ARGB(255,255,255,255));
	gSprite->Flush();

	D3DXMatrixScaling(&scaleMat, 2.0f, 2.0f, 2.0f);
	worldMat = scaleMat * worldMat;
	D3DXMatrixTranslation(&worldMat, gApplication->GetWindowSize().x / 8.0f, gApplication->GetWindowSize().y / 4.0f, 0.0f);
	gSprite->SetTransform(&worldMat);
	gSprite->Draw(gAssets->GetTexture("Credits_Text.png"), 0, 0, 0, D3DCOLOR_ARGB(255,255,255,255));
	gSprite->Flush();

}