#include "GameStatePlayerGuide.h"
#include "DirectInput.h"
#include "DirectX9App.h"
#include "FMODAudio.h"


GameStatePlayerGuide::GameStatePlayerGuide()
{
	
}

GameStatePlayerGuide::~GameStatePlayerGuide()
{



}

GameStatePlayerGuide* GameStatePlayerGuide::Instance()
{
	static GameStatePlayerGuide instance;
	return &instance;
}

void GameStatePlayerGuide::Enter(DirectX9Game* owner)
{

}

void GameStatePlayerGuide::Execute(DirectX9Game* owner, float dt)
{
	//Start Game on Enter
	if(gInput->KeyDown(DIK_RETURN))
	{
		gAudio->PlaySoundFX("Cannon_Fire.wav");
		owner->GetFSM()->ChangeState(GameStatePlaying::Instance());
	}
}


void GameStatePlayerGuide::Exit(DirectX9Game* owner)
{

}


void GameStatePlayerGuide::Render(DirectX9Game* owner)
{
	D3DXMATRIX worldMat, transMat, scaleMat;

	//Draw Background
	D3DXMatrixScaling(&scaleMat, 0.7f, 1.0f, 1.0f);
	D3DXMatrixTranslation(&worldMat, -40.0f, 0.0f, 0.0f);
	worldMat = scaleMat * worldMat;
	gSprite->SetTransform(&worldMat);
	gSprite->Draw(gAssets->GetTexture("Tank_Background.png"), 0, 0, 0, D3DCOLOR_ARGB(255,255,255,255));
	gSprite->Flush();

	D3DXMatrixTranslation(&transMat, 12, 8, 0);
	D3DXMatrixScaling(&scaleMat, 1.2f, 1.0f, 0);
	gSprite->SetTransform(&(transMat * scaleMat));
	gSprite->Draw(gAssets->GetTexture("Player_Guide_Text.png"), 0, 0, 0, D3DCOLOR_ARGB(255,255,255,255));
	gSprite->Flush();
}


