#include "GameStatePlaying.h"
#include "Defines.h"
#include "DirectX9App.h"
#include "DirectInput.h"
#include "D3DXMathFunctions.h"
#include "DirectX9Game.h"
#include "GameStateMenuGameOver.h"
#include "GameStateHighScore.h"
#include "GameStatePlayerGuide.h"
#include "ActorFactory.h"
#include "AssetManager.h"
#include "FMODAudio.h"

GameStatePlaying::GameStatePlaying()
{
	
}

GameStatePlaying::~GameStatePlaying()
{
	
}

GameStatePlaying* GameStatePlaying::Instance()
{
	static GameStatePlaying instance;
	return &instance;
}

void GameStatePlaying::Enter(DirectX9Game*)
{
	gAssets->LoadGameAssets();
	gFactory->CreateCamera(D3DXVECTOR3(0.0,3.0,-10.0), D3DXVECTOR3(0.0,0.0,1.0));
	gFactory->CreatePlayer(D3DXZEROVEC3);
	gFactory->CreateHUD();
	gFactory->CreateSkyBox();
	gFactory->CreateEnemyTank(D3DXVECTOR3(0,0,100));
	gFactory->CreateAmmoPickup(D3DXVECTOR3(100,0,100));
	gFactory->CreateRepairPickup(D3DXVECTOR3(-100,0,-100));
	gFactory->CreateAmmoPickup(D3DXVECTOR3(-100,0,100));
	gFactory->CreateRepairPickup(D3DXVECTOR3(-100,0,100));
	gApplication->EnableFullScreenMode(true);
	gAudio->StopSong();
	gAudio->PlaySong("Game.mp3");
}

void GameStatePlaying::Execute(DirectX9Game* owner, float dt)
{
	gActors->Update(dt);
}

void GameStatePlaying::Render(DirectX9Game*)
{
	gActors->Render();
}

void GameStatePlaying::Exit(DirectX9Game*)
{
	gApplication->EnableFullScreenMode(false);
}