#include "HUD.h"
#include "DirectX9App.h"
#include "DirectX9Game.h"
#include <sstream>
#include "PlayerTank.h"
#include "AssetManager.h"
#include "AITank.h"
#include "ActorManager.h"

HUD::HUD(int ID):Actor(ID)
{
	
}

void HUD::Render()
{
	PlayerTank* player = (PlayerTank*)gActors->GetPlayer();
	//Icon Color - Scales from 10, 140, 0 (bright green) at full health to 140, 10, 0 (bright red) at no health
	int health = player->GetHealth();
	int red = (int)(10 + (100 - health) * 1.4);
	int green = (int)(10 + health * 1.4);

	//Render Tank Icon
	D3DXMATRIX transMat, rotMat, scaleMat, worldMat;
	D3DXMatrixScaling(&scaleMat, 0.125, 0.125 ,0.0);
	D3DXMatrixTranslation(&transMat, 100.0f, (gApplication->GetWindowSize().y - 150.0f), 0.0f);
	D3DXMatrixRotationZ(&rotMat, D3DX_PI/2.0f);
	D3DXMatrixMultiply(&scaleMat, &scaleMat, &rotMat);
	D3DXMatrixMultiply(&worldMat, &scaleMat, &transMat);
	gSprite->SetTransform(&worldMat);
	gSprite->Draw(gAssets->GetTexture("Tank_HUD.png"), 0, 0, 0, D3DCOLOR_ARGB(255,red,green,0));
	gSprite->Flush();

	//Render Ammo Icons
	//Machine Gun
	for(int i = 0; i < player->GetTank()->GetMachineGunAmmo(); i +=5)
	{
		D3DXMatrixScaling(&scaleMat, 0.25, 0.25 ,0.0);
		D3DXMatrixTranslation(&transMat, (115.0f + (float)(i * 4)), (gApplication->GetWindowSize().y *0.91f), 0.0f);
		D3DXMatrixMultiply(&worldMat, &scaleMat, &transMat);
		gSprite->SetTransform(&worldMat);
		gSprite->Draw(gAssets->GetTexture("HUD_Bullet.png"), 0, 0, 0, D3DCOLOR_ARGB(255,255,255,0));
		gSprite->Flush();
	}
	//Main Cannon
	for(int i = 0; i < player->GetTank()->GetMainGunAmmo(); i++)
	{
		D3DXMatrixScaling(&scaleMat, 0.25, 0.25 ,0.0);
		D3DXMatrixTranslation(&transMat, (115.0f + (float)(i * 24)), (gApplication->GetWindowSize().y *0.83f), 0.0f);
		D3DXMatrixMultiply(&worldMat, &scaleMat, &transMat);
		gSprite->SetTransform(&worldMat);
		gSprite->Draw(gAssets->GetTexture("HUD_Shell.png"), 0, 0, 0, D3DCOLOR_ARGB(255,255,255,0));
		gSprite->Flush();
	}

	//Render Score
	D3DXMatrixIdentity(&worldMat);
	D3DXMatrixScaling(&worldMat, 2, 2, 0);
	gSprite->SetTransform(&worldMat);
	std::stringstream score;
	score << "Score: " << DirectX9Game::Instance()->GetScore();
	gApplication->GetDefaultFont()->DrawText(gSprite, score.str().c_str(), -1, 0, DT_TOP | DT_NOCLIP, D3DCOLOR_ARGB(255,0,0,0));
}