#pragma once
#include "d3dx9.h"


class Physics
{
	D3DXVECTOR3 m_Position;
	D3DXVECTOR3 m_Velocity;
	D3DXVECTOR3 m_Acceleration;
	float		m_Rotation;
	float		m_ContactRadius;
	float		m_MaxAccel;
	float		m_MaxSpeed;
	float		m_MaxRotationSpeed;
	D3DXVECTOR3 m_Gravity;
	float		m_FrictionForce;
	


public:
	Physics(){}
	~Physics(){}

	void Init(D3DXVECTOR3 position, D3DXVECTOR3 velocity, float contactRadius, float maxAccel, float maxSpeed, float maxRotationSpeed, D3DXVECTOR3 gravity);
	void Accelerate(D3DXVECTOR3 accel){m_Acceleration += accel;}
	void Update(float dt);
	void SetPosition(D3DXVECTOR3 position){m_Position = position;}
	D3DXVECTOR3 GetPosition(){return m_Position;}
	D3DXVECTOR3 GetVelocity(){return m_Velocity;}
	float GetContactRadius(){return m_ContactRadius;}
	float GetMaxAccel(){return m_MaxAccel;}
	float GetMaxSpeed(){return m_MaxSpeed;}
	float GetMaxRotationSpeed(){return m_MaxRotationSpeed;}
	float GetRotation(){return m_Rotation;}
	void Stop();
};