#pragma once
#include "Actor.h"
#include "d3dx9.h"

class RepairPickup : public Actor
{
	D3DXVECTOR3 m_Position;
	float		m_Timeout;
	float		m_CooldownTime;
	float		m_Rotation;
	bool		m_IsActive;
	int			m_AmountHealed;
	float		m_ContactRadius;
	D3DXHANDLE				m_hTech;
	D3DMATERIAL9			m_Material;

public:
	bool IsActive(){return m_IsActive;}
	RepairPickup(int ID);
	void Update(float dt);
	void Render();
	void ReceiveMessage(Telegram incoming);
	void SetPosition(D3DXVECTOR3 position){m_Position = position;}
	D3DXVECTOR3 GetPosition(){return m_Position;}
	float GetContactRadius(){return m_ContactRadius;}
	int GetAmount(){return m_AmountHealed;}
};

class AmmoPickup : public Actor
{
	D3DXVECTOR3 m_Position;
	float		m_Timeout;
	float		m_CooldownTime;
	float		m_Rotation;
	bool		m_IsActive;
	int			m_AmountReloaded;
	float		m_ContactRadius;
	D3DXHANDLE				m_hTech;
	D3DMATERIAL9			m_Material;

public:
	bool IsActive(){return m_IsActive;}
	AmmoPickup(int ID);
	void Update(float dt);
	void Render();
	void ReceiveMessage(Telegram incoming);
	void SetPosition(D3DXVECTOR3 position){m_Position = position;}
	D3DXVECTOR3 GetPosition(){return m_Position;}
	float GetContactRadius(){return m_ContactRadius;}
	int GetAmount(){return m_AmountReloaded;}
};