// Projectile.h - Creates the bullets and shells fired.

#pragma once

#include "Actor.h"
#include "Physics.h"
#include "Messenger.h"

class Projectile : public Actor
{
	Physics m_Physics;
	float m_FlightTime;
	int	m_Damage;
	float m_Scale;
	int m_Owner;

	D3DXHANDLE				m_hTech;
	D3DMATERIAL9			m_Material;

public:
	Projectile(int ID, int owner, float flightTime, int damage, float scale);
	void Update(float dt);
	void Render();
	Physics* GetPhysics(){return &m_Physics;}
	void ReceiveMessage(Telegram);
	
};