// Skybox.h - Cube that shows the horizon.

#pragma once

#include "DirectX9App.h"
#include "Actor.h"
#include "Messenger.h"

class SkyBox : public Actor
{
	//////////////////////////////////////////////////////////////////////////
	// Vertex Declaration and Vertex and Index Buffers
	//////////////////////////////////////////////////////////////////////////
	struct Vertex
	{
		D3DXVECTOR3 position;
		D3DXVECTOR3 normal;
		D3DXVECTOR2 uv;
	};

	// Cube data (Vertex and Index array)
	Vertex m_CubeVerts[24];	
	WORD m_CubeIndices[36];

	IDirect3DVertexDeclaration9*	m_D3DVertexDecl;

	// Vertex Buffer
	IDirect3DVertexBuffer9*			m_D3DVertexBuffer;
	// Index Buffer
	IDirect3DIndexBuffer9*			m_D3DIndexBuffer;

	D3DMATERIAL9			m_Material;
	D3DXHANDLE				m_hTech;
public:
	SkyBox(int ID);
	void Render();

	//Required for Actor overload but unused.
	void Update(float){};
	void ReceiveMessage(Telegram){};
};