#pragma once

//State base. Includes a render method to allow it to be overloaded for Game and Menu States.
template<class t>
class State
{
public:
	virtual ~State(){};
	virtual void Enter(t*) = 0;
	virtual void Execute(t*, float dt) = 0;
	virtual void Exit(t*) = 0;
	virtual void Render(t*) = 0;
};