#pragma once

#include "d3dx9.h" //For D3D Math functions
#include <vector>
#include "Actor.h"

struct SteeringForce
{
	D3DXVECTOR3 linear;
};

class Agent;

class Steering
{
	Actor*	m_Owner;
	//Steering Weights
	D3DXVECTOR3		m_SeekTarget;
	D3DXVECTOR3		m_FleeTarget;
	D3DXVECTOR3		m_ArriveTarget;
	float			m_SeekWeight;
	float			m_ArriveWeight;
	float			m_FleeWeight;
	
	//Control Variables
	bool			m_Seeking;
	bool			m_Fleeing;
	bool			m_Arriving;
	bool			m_Wandering;

	//Arrive variables
	float			m_ArriveRadius;			//Acceptable range from target to arrive at.
	float			m_ArriveSlowRadius;		//Radius to start slowing down at
	float			m_ArriveTime;			//Time it should take to arrive
	
public:
	Steering(Actor* owner);
	~Steering();

	//Seek Setter/Getter
	void Seek(D3DXVECTOR3 target, float weight);
	void SeekOff();
	bool IsSeeking();

	//Flee Setter/Getter
	void Flee(D3DXVECTOR3 target, float weight);
	void FleeOff();
	bool IsFleeing();

	//Arrive Setter/Getter
	void Arrive(D3DXVECTOR3 target, float arriveRadius, float arriveSlowRadius, float arriveTime, float weight);
	void ArriveOff();
	bool IsArriving();

	//Steering Force Calculation
	SteeringForce Calculate();
};


